//+------------------------------------------------------------------+
//|                                                 Account_Info.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   string com="";
//---   
   string account_currency=AccountInfoString(ACCOUNT_CURRENCY);

//---      
   double balance=AccountInfoDouble(ACCOUNT_BALANCE);
   double equity=AccountInfoDouble(ACCOUNT_EQUITY);

//---         
   string format=StringFormat("Balance = %.2f, Equity = %.2f",balance,equity);
   StringAdd(com,format);
   StringAdd(com,"\r\n");

//---         
   double margin=AccountInfoDouble(ACCOUNT_MARGIN);
   double float_profit=AccountInfoDouble(ACCOUNT_PROFIT);

//---           
   format=StringFormat("Margin = %.2f %%, Float Profit = %.2f ",margin,float_profit);
   StringAdd(com,format);
   StringAdd(com,"\r\n");

//---          
   double free_margin=AccountInfoDouble(ACCOUNT_FREEMARGIN);
   format=StringFormat("Free Margin = %G ",free_margin);
   StringAdd(com,format);
   StringAdd(com,"\r\n");

//---    com   
   StringAdd(com,"Account Currency: "+account_currency);
   StringAdd(com,"\r\n");

//--- ,    Stop Out
   double stopout_level=AccountInfoDouble(ACCOUNT_MARGIN_SO_SO);

//---   Stop Out
   ENUM_ACCOUNT_STOPOUT_MODE so_mode=(ENUM_ACCOUNT_STOPOUT_MODE)AccountInfoInteger(ACCOUNT_MARGIN_SO_MODE);
   if(so_mode==ACCOUNT_STOPOUT_MODE_PERCENT)
      StringAdd(com," Stop Out    : "+StringFormat("%.2f%%",stopout_level));
   else
      StringAdd(com," Stop Out        "
                +StringFormat("%.2f %s",stopout_level,account_currency));
   StringAdd(com,"\r\n");

//---      
   double margin_level=AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
   StringAdd(com,StringFormat("Account margin level =  %.2f%%",margin_level));
   StringAdd(com,"\r\n");

//---     
   StringAdd(com,"\r\n");
//---    
   int leverage=(int)AccountInfoInteger(ACCOUNT_LEVERAGE);
   StringAdd(com,StringFormat(": 1/%d",leverage));
   StringAdd(com,"\r\n");

//---   
   long login=AccountInfoInteger(ACCOUNT_LOGIN);
//---  
   ENUM_ACCOUNT_TRADE_MODE mode=(ENUM_ACCOUNT_TRADE_MODE)AccountInfoInteger(ACCOUNT_TRADE_MODE);
   StringAdd(com,StringFormat("  %d ",login));
   switch(mode)
     {
      case ACCOUNT_TRADE_MODE_DEMO:    StringAdd(com," demo");       break;
      case ACCOUNT_TRADE_MODE_CONTEST: StringAdd(com," "); break;
      case ACCOUNT_TRADE_MODE_REAL:    StringAdd(com," ");   break;
      default:                         StringAdd(com,"  ");
     }
   StringAdd(com,"\r\n");

//--- ,    
   bool trade_allowed=(bool)AccountInfoInteger(ACCOUNT_TRADE_ALLOWED);
   if(trade_allowed)
      StringAdd(com," ");
   else
      StringAdd(com," ");
   StringAdd(com,"\r\n");

//--- ,      
   if(trade_allowed)
     {
      bool trade_expert=(bool)AccountInfoInteger(ACCOUNT_TRADE_EXPERT);
      if(trade_expert)
         StringAdd(com,"   ");
      else
         StringAdd(com,"   ");
      StringAdd(com,"\r\n");
     }
//---   com  
   Comment(com);
  }
//+------------------------------------------------------------------+
