//+------------------------------------------------------------------+
//|                                          SymbolInfo_Advanced.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    "" 
   string com="\r\n";
   StringAdd(com,Symbol());
   StringAdd(com,"\r\n");

//---   
   double lot_size=SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE);

//---  
   string margin_currency=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_MARGIN);
   StringAdd(com,StringFormat("C : %.2f %s",lot_size,margin_currency));
   StringAdd(com,"\r\n");

//---  
   int leverage=(int)AccountInfoInteger(ACCOUNT_LEVERAGE);
   StringAdd(com,StringFormat(": 1/%d",leverage));
   StringAdd(com,"\r\n");

//---      
   StringAdd(com,"     1   ");

//---      
   double margin=GetMarginForOpening(1,Symbol(),POSITION_TYPE_BUY)/leverage;
   StringAdd(com,DoubleToString(margin,2));
   StringAdd(com," "+AccountInfoString(ACCOUNT_CURRENCY));

   Comment(com);
  }
//+------------------------------------------------------------------+
//|    ,         |
//+------------------------------------------------------------------+
double GetMarginForOpening(double lot,string symbol,ENUM_POSITION_TYPE direction)
  {
   double answer=0;
//---   
   double lot_size=SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE);

//---   
   string account_currency=AccountInfoString(ACCOUNT_CURRENCY);

//--- ,        
   string margin_currency=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_MARGIN);

//---  
   string profit_currency=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_PROFIT);

//---   
   string calc_currency="";
//---   - true,  - false
   bool mode;

//---        
   if(profit_currency==account_currency)
     {
      calc_currency=symbol;
      mode=true;
     }

//---         
   if(margin_currency==account_currency)
     {
      calc_currency=symbol;
      //---    ,    
      return(lot*lot_size);
     }

//---         
//---     
   if(calc_currency=="")
     {
      calc_currency=GetSymbolByCurrencies(margin_currency,account_currency);
      mode=true;
      //---     NULL,     
      if(calc_currency==NULL)
        {
         //---  
         calc_currency=GetSymbolByCurrencies(account_currency,margin_currency);
         mode=false;
        }
     }

//---        
   if(calc_currency=="" || calc_currency==NULL)
     {
      Print(__FUNCTION__,"          "+symbol);
      return(NULL);
     }

//---    ,     
   MqlTick tick;
   SymbolInfoTick(calc_currency,tick);

//---     , 
   double calc_price;
//---   
   if(direction==POSITION_TYPE_BUY)
     {
      //---  
      if(mode)
        {
         //---       
         calc_price=tick.ask;
         answer=lot*lot_size*calc_price;
        }
      //---   
      else
        {
         //---       
         calc_price=tick.bid;
         answer=lot*lot_size/calc_price;
        }
     }

//---   
   if(direction==POSITION_TYPE_SELL)
     {
      //---  
      if(mode)
        {
         //---       
         calc_price=tick.bid;
         answer=lot*lot_size*calc_price;
        }
      //---   
      else
        {
         //---       
         calc_price=tick.ask;
         answer=lot*lot_size/calc_price;
        }
     }

//---   -     ,       
   return(answer);
  }
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
string GetSymbolByCurrencies(string margin_currency,string profit_currency)
  {
//---     ,     " "
   for(int s=0;s<SymbolsTotal(true);s++)
     {
      //---        " "
      string symbolname=SymbolName(s,true);

      //---   
      string m_cur=SymbolInfoString(symbolname,SYMBOL_CURRENCY_MARGIN);

      //---    (      )
      string p_cur=SymbolInfoString(symbolname,SYMBOL_CURRENCY_PROFIT);

      //---       ,    
      if(m_cur==margin_currency && p_cur==profit_currency) return(symbolname);
     }
   return(NULL);
  }
//+------------------------------------------------------------------+
